pwstore-cli
===========

About
-----

This is a simple command line interface to Peter Scott's pwstore
library.  It allows

 * generation of password hashes from a given password;
 * verification that a given password hash match a given password; and
 * strengthening a given password hash.

Building and Installing
-----------------------

In most cases you can build and install this program using the regular
cabal commands

    $ cabal configure
    $ cabal build
    $ cabal install

Alternatively, if you wish to build the program such that it uses
`pwstore-purehaskell`, rather than `pwstore-fast` then disable the
"fast" flag.  That is, change the configure command to

    $ cabal configure -f '-fast'

Examples
--------

This is an example shell session running a few variants of the pwstore
command.

    $ pwstore
    Password:
    Repeat password:
    sha256|12|F8+RyvEYct+f3u0OIXf7zA==|vG8+SvGD78BbNP5cO4yFyIxvauRMK5DLf3cMFWex804=
    $ pwstore <<<hunter2
    sha256|12|nFXB28V2In4jg3XT7FnREw==|MQP6yr9RcyRm7J72dtruzseBfQFC31WKQWRxY225KWo=
    $ pwstore verify 'sha256|12|nFXB28V2In4jg3XT7FnREw==|MQP6yr9RcyRm7J72dtruzseBfQFC31WKQWRxY225KWo=' <<<hunter2
    good password
    $ pwstore verify 'sha256|12|nFXB28V2In4jg3XT7FnREw==|MQP6yr9RcyRm7J72dtruzseBfQFC31WKQWRxY225KWo=' <<<hello
    bad password
    $ pwstore strengthen -s 13 'sha256|12|nFXB28V2In4jg3XT7FnREw==|MQP6yr9RcyRm7J72dtruzseBfQFC31WKQWRxY225KWo='
    sha256|13|nFXB28V2In4jg3XT7FnREw==|vkeWCO9CA1ZPlInaoLlR4Ei5c+Y6EVLZdi5ucrQED5g=
    $ pwstore verify 'sha256|12|nFXB28V2In4jg3XT7FnREw==|MQP6yr9RcyRm7J72dtruzseBfQFC31WKQWRxY225KWo=' <<<hello
    bad password
    $ pwstore verify 'sha256|13|nFXB28V2In4jg3XT7FnREw==|vkeWCO9CA1ZPlInaoLlR4Ei5c+Y6EVLZdi5ucrQED5g=' <<<hunter2
    good password
